{$r+}
const maxstate=20;
      maxcon=10;
      maxdis=10;
type st5=string[5];
     st10=string[10];
     st20=string[20];
     con=record
           qc: byte;
           con: array [1..maxcon] of st10;
         end;
var i,j,k,l,m, sqty, qstat, n, qdig, msk: byte;
    s, s1: string;
    t, t1: text;
    i1: integer;
    terms: array [1..maxstate] of record
                                    qd: byte;
                                    dis: array [1..maxdis] of con;
                                  end;
    names: array [1..maxstate] of st10;
    b2, fl, erf: boolean;
    setb: set of byte;

procedure trc(var s: string);
var i: byte;
begin
  i:=1;
  while i<=length(s) do if s[i]=' ' then delete(s, i, 1) else inc(i);
  for i:=1 to length(s) do s[i]:=upcase(s[i]);
  for i:=1 to length(s) do if s[i]='-' then s[i]:='^';
  for i:=1 to length(s) do if s[i]='V' then s[i]:='|';
end;
function to10(s: st10): st5;
var s1: st5;
    i, j, k: byte;
begin
  j:=1;
  k:=0;
  for i:=1 to length(s) do
      begin
        inc(k, (ord(s[length(s)-i+1])-48)*j);
        j:=2*j;
      end;
  str(k, s1);
  to10:=s1;
end;
function to02(s: st10): st10;
var i, j: byte;
begin
  if s[1] in ['0'..'9'] then
     begin
       for j:=1 to qdig-length(s) do s:='0'+s;
     end;
  to02:=s;
end;
function to2(s: string): st10;
var s1: st10;
    i, j, k: byte;
begin
  if s[1] in ['0'..'9'] then
     begin
       val(s, k, i1);
       if i1>0 then
          begin
            writeln('Error Decimal Value Expected.');
            close(t);
            halt(2);
          end;
       s1:='';
       i:=msk;
       for j:=1 to qdig do
           begin
             if k>=i then
                begin
                  s1:=s1+'1';
                  k:=k-i;
                end
                 else s1:=s1+'0';
             i:=i shr 1;
           end;
       to2:=s1;
     end
      else to2:=s;
end;

begin
  if paramcount<>2 then
     begin
       writeln('* NC *  30-Nov-93  D-Flip-Flops Analyzer of Graph');
       writeln('Usage: D-Fl-Fl <InFile> <OutFile>');
       halt(2);
     end;
  assign(t, paramstr(1));
  reset(t);
  readln(t, s);
  trc(s);
  if (length(s)<2) or ((s[1]<>'D') and (s[1]<>'B')) then
     begin
       writeln('First Line Must Be: <Base><StateQty>');
       close(t);
       halt(2);
     end;
  val(copy(s, 2, length(s)-1), sqty, i1);
  if i1>0 then
     begin
       writeln('First Line Must Be: <Base><StateQty>');
       close(t);
       halt(2);
     end;
  msk:=128;
  qdig:=8;
  while msk>sqty do
        begin
          msk:=msk shr 1;
          dec(qdig);
        end;
  b2:=s[1]='B';

  erf:=false;
  n:=0;
  qstat:=0;
  fl:=true;
  while not eof(t) and not erf do
        begin
          inc(n);
          readln(t, s);
          trc(s);
          fl:=s>'';
          if fl then erf:=pos('=', s)<2;
          if erf then writeln('Error In Line ', n, ': "=" Expected.');
          if fl and not erf then
             begin
               inc(qstat);
               names[qstat]:=copy(s, 1, pos('=', s)-1);
               if not b2 then names[qstat]:=to2(names[qstat])
                  else names[qstat]:=to02(names[qstat]);
               delete(s, 1, pos('=', s));
               erf:=s='';
               if erf then writeln('Error In Line ', n, ': UnExpecter EOL.');
               terms[qstat].qd:=0;
               while s>'' do
                     begin
                       inc(terms[qstat].qd);
                       terms[qstat].dis[terms[qstat].qd].qc:=0;
                       while (s>'') and fl do
                             begin
                               i:=pos('*', s);
                               j:=pos('|', s);
                               if ((i<j) and (i>0)) or (j=0) then l:=i
                                  else
                                   begin
                                     l:=j;
                                     fl:=false;
                                   end;
                               inc(terms[qstat].dis[terms[qstat].qd].qc);
                               k:=terms[qstat].dis[terms[qstat].qd].qc;
                               if l>0 then
                                  begin
                                    s1:=copy(s, 1, l-1);
                                    delete(s, 1, l);
                                  end
                                   else
                                    begin
                                      s1:=s;
                                      s:='';
                                    end;
                               if b2 or not (s1[1] in ['0'..'9'])
                                  then terms[qstat].dis[terms[qstat].qd].con[k]:=to02(s1)
                                  else terms[qstat].dis[terms[qstat].qd].con[k]:=to2(s1);
                             end;
                       fl:=true;
                     end;
             end;
        end;
  close(t);
  if erf then halt(2);
  if qstat<>sqty then
     begin
       writeln('Declared QStat MisMatch with Calculated.');
       halt(2);
     end;
  setb:=[];
  for i:=1 to qstat do setb:=setb+[i];
  for i:=1 to qstat do
      begin
        val(to10(names[i]), j, i1);
        if i1>0 then
           begin
             writeln('Decimal Value Expected.');
             halt(2);
           end;
        setb:=setb-[j];
      end;
  if setb<>[] then
     begin
       writeln('Some States Missing.');
       halt(2);
     end;
  for i:=1 to qstat do {Sorting}
      for j:=1 to terms[i].qd do
          for k:=1 to terms[i].dis[j].qc-1 do
              for l:=k+1 to terms[i].dis[j].qc do
                  if terms[i].dis[j].con[l]<terms[i].dis[j].con[k] then
                     begin
                       s:=terms[i].dis[j].con[l];
                       terms[i].dis[j].con[l]:=terms[i].dis[j].con[k];
                       terms[i].dis[j].con[k]:=s;
                     end;

  for i:=1 to qstat do {Excluding of equal vars in each conjunction}
      for j:=1 to terms[i].qd do
          begin
            k:=1;
            while k<=terms[i].dis[j].qc-1 do
                  begin
                    l:=k+1;
                    while l<=terms[i].dis[j].qc do
                          if terms[i].dis[j].con[k]=terms[i].dis[j].con[l] then
                             begin
                               for m:=l+1 to terms[i].dis[j].qc do
                                   terms[i].dis[j].con[m-1]:=terms[i].dis[j].con[m];
                               dec(terms[i].dis[j].qc);
                             end
                              else inc(l);
                    inc(k);
                  end;
          end;

  for i:=1 to qstat do {Excluding of SubPart}
      begin
        j:=1;
        while j<=terms[i].qd-1 do
              begin
                k:=j+1;
                while k<=terms[i].qd do
                      begin
                        s:='*';
                        for l:=1 to terms[i].dis[j].qc do
                            s:=s+terms[i].dis[j].con[l]+'*';
                        m:=0;
                        for l:=1 to terms[i].dis[k].qc do
                            if pos('*'+terms[i].dis[k].con[l]+'*', s)>0 then
                               begin
                                 inc(m);
                                 delete(s, pos('*'+terms[i].dis[k].con[l]+'*', s)+1,
                                        length(terms[i].dis[k].con[l])+1);
                               end;
                        if (s='*') or (m=terms[i].dis[k].qc) then
                           if s<>'*' then
                              begin
                                for l:=j+1 to terms[i].qd do
                                    terms[i].dis[l-1]:=terms[i].dis[l];
                                dec(terms[i].qd);
                                k:=terms[i].qd+1;
                                dec(j);
                              end
                               else
                                begin
                                  for l:=k+1 to terms[i].qd do
                                      terms[i].dis[l-1]:=terms[i].dis[l];
                                  dec(terms[i].qd);
                                end
                            else inc(k);
                      end;
                inc(j);
              end;
      end;
  assign(t1, paramstr(2));
  rewrite(t1);
  writeln(t1, 'Source:');
  for i:=1 to qstat do
      begin
        write(t1, names[i], '<=>');
        for j:=1 to terms[i].qd do
            begin
              for k:=1 to terms[i].dis[j].qc do
                  begin
                    write(t1, terms[i].dis[j].con[k]);
                    if k<terms[i].dis[j].qc then write(t1, '<*>');
                  end;
              if j<terms[i].qd then write(t1, '<|>');
            end;
        writeln(t1);
      end;
  writeln(t1);
  writeln(t1, qdig, ' D-Flip-Flops Requred for This Circuit.');
  writeln(t1, 'Results:');
  for i:=1 to qdig do
      begin
        str(i-1, s);
        s:='d'+s+'=';
        for j:=1 to qstat do
            if names[j][length(names[j])-i+1]='1' then
               begin
                 for k:=1 to terms[j].qd do
                     begin
                       for l:=1 to terms[j].dis[k].qc do
                           begin
                             if terms[j].dis[k].con[l][1] in ['0'..'1'] then
                                for m:=1 to length(terms[j].dis[k].con[l]) do
                                    begin
                                      if terms[j].dis[k].con[l][m]='1' then
                                         s:=s+'q' else s:=s+'^q';
                                      str(length(terms[j].dis[k].con[l])-m, s1);
                                      s:=s+s1;
                                      if m<length(terms[j].dis[k].con[l]) then
                                         s:=s+'*';
                                    end
                                 else s:=s+terms[j].dis[k].con[l];
                             if l<terms[j].dis[k].qc then s:=s+'*';
                           end;
                       s:=s+' | ';
                     end;
               end;
        dec(s[0], 3);
        for j:=1 to length(s) do s[j]:=upcase(s[j]);
        writeln(t1, s);
      end;
  close(t1);
  writeln('Good Luck.');
end.
